<?php

namespace FiloBlu\Refilo\Model\Exporter;

use FiloBlu\Refilo\Model\Adapter\Mongo;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\ResourceConnection;
use Magento\Store\Model\StoreManagerInterface;

class Urls
{
    /**
     * @var ResourceConnection
     */
    private $resourceConnection;
    /**
     * @var Mongo
     */
    private $mongo;
    /**
     * @var ScopeConfigInterface
     */
    private $scopeConfig;
    /**
     * @var StoreManagerInterface
     */
    private $storeManager;

    /**
     * Menu constructor.
     * @param ResourceConnection $resourceConnection
     * @param ScopeConfigInterface $scopeConfig
     * @param Mongo $mongo
     * @param StoreManagerInterface $storeManager
     */
    public function __construct(
        ResourceConnection $resourceConnection,
        ScopeConfigInterface $scopeConfig,
        Mongo $mongo,
        StoreManagerInterface $storeManager
    ) {
        $this->resourceConnection = $resourceConnection;
        $this->scopeConfig = $scopeConfig;
        $this->mongo = $mongo;
        $this->storeManager = $storeManager;
    }

    public function exportUrls()
    {
        $tableName = $this->resourceConnection->getTableName('url_rewrite');
        $bulkData = [];

        $query = "SELECT $tableName.*,store.code as store_code FROM $tableName INNER JOIN store on store.store_id = $tableName.store_id WHERE $tableName.store_id != 0";

        $result = $this->resourceConnection->getConnection()->fetchAll($query);
        foreach ($result as $item) {
            $url = new \stdClass();

            $url->_id = $item['url_rewrite_id'];
            $url->url_id = $item['url_rewrite_id'];
            $url->type = $item['entity_type'];
            $url->entity_id = $item['entity_id'];
            $url->url = $item['request_path'];
            $url->is_redirect = $item['redirect_type'];
            $url->target_url = $item['target_path'];
            $url->store = $item['store_code'];

            $bulkData[] = $url;
        }
        $this->mongo->update(
            '_id',
            $bulkData,
            'urls',
            true,
            $this->scopeConfig->getValue('mongo/general/mongo_general_database')
        );
    }
}
